#include <stdio.h>
#include <math.h>
#include <malloc.h>

struct List {
	int a;
	struct List* next;
}; typedef struct List L;

L* create(int count)
{
	L* start = malloc(sizeof(L));
	start->a = 0;
	start->next = NULL;

	L* point1, * point2;
	point1 = start;
	for (int i = 0; i < count-1; i++)
	{
		point2 = malloc(sizeof(L));
		point2->a =i*i;
		point1->next = point2;
		point1 = point2;
	}
	point1->next = NULL;
	return start;
}

void show(L* list) 
{
	while (list) 
	{
		printf("%d\t", list->a);
		list = list->next;
	}
	printf("\n");
}

L* deleteInList(L* list, int el) 
{
	L* temp = list, * pred = NULL;
	if (temp != NULL && temp->a == el)
	{
		list = temp->next;
		free(temp);
		return list;
	}

	while (temp != NULL && temp->a != el)
	{
		pred = temp;
		temp = temp->next;
	}

	if (temp == NULL) 
	{
		printf("    !   : ");
		int newEl = 0;
		scanf_s("%d",&newEl);
		return deleteInList(list, newEl);
	}
	else
	{
		pred->next = temp->next;
		free(temp);
		return list;
	}
}

L* deleteList(L* list)
{
	L* listCopy = list;
	while (listCopy)
	{
		listCopy = list->next;
		free(list);
		list = listCopy;
	}
}

void createMas()
{
	int s;
	printf("\n  : ");
	scanf_s("%d", &s);
	int** mas = malloc(s * sizeof(int*));
	int num = 0;
	for (int i = 0; i < s; i++)
	{
		mas[i] = malloc((i + 1) * sizeof(int));
		for (int j = 0; j <= i; j++)
		{			
			mas[i][j] = num++;
		}
		num = 0;
	}
	for (int i = 0; i < s; i++)
	{		
		for (int j = 0; j <= i; j++)
		{
			printf("%d\t", mas[i][j]);
		}
		printf("\n");
	}
	/*int s1 = s;
	for (int i = 0; i < s1; i++)
	{
		mas[i] = malloc((i + 1) * sizeof(int));
		for (int j = 0; j < s1; j++)
		{
			mas[i][j] = num++;			
		}
		s1--;
		num = 0;
		mas[i][0] = num;
	}
	printf("\n");
	s1 = s;
	for (int i = 0; i < s; i++)
	{
		for (int j = 0; j < s; j++)
		{
			printf("%d\t", mas[i][j]);
		}
		s--;
		printf("\n");
	}*/

	for (int i = 0; i < s; i++)
	{
		free(mas[i]);
	}
	free(mas);
}

int main(void)
{
	system("chcp 1251>nul");
	/*L* list = create(10);	
	show(list);
	printf("\n      : ");
	int el = 0;
	scanf_s("%d", &el);
	list = deleteInList(list, el);
	show(list);
	printf("\n \n");
	system("pause");
	deleteList(list);
	printf(" \n");*/

	createMas();
}
